com.saxonica.stream.watch

## Class AccumulatorWatch

- java.lang.Object
- - com.saxonica.validate.AbstractWatch
  - - com.saxonica.stream.watch.AccumulatorWatch

- All Implemented Interfaces:
    Watch

      public class AccumulatorWatch
      extends AbstractWatch

  This watch implements a single accumulator in streaming mode. Unlike other watches, it is called to process every node in the stream; it then checks whether the accumulator has any rule that matches this node, and if so applies the next-value expression associated with that accumulator rule.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AccumulatorWatch(Accumulator accumulator)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` The close() method is called immediately before the Watch is destroyed, that is, when the element whose declaration scopes the constraint implemented by this Watch goes out of scope.
    `void` | `endSelectedParentNode(int locationId)` Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
    `XPathContext` | `getContext()`
    `Sequence` | `getPostDescentValue()`
    `Sequence` | `getPreDescentValue()`
    `void` | `notifySelectedLeafNode(FleetingNode node, int locationId)` Signal that a node (other than an element) that matches the selection has been found.
    `void` | `open()` Open the watch.
    `void` | `setWatchManager(WatchManager watchManager)`
    `Receiver` | `startSelectedParentNode(FleetingNode node, int locationId)` Signal that an element has been found that matches the selection that this Watch is looking for.

    - ### Methods inherited from class com.saxonica.validate.AbstractWatch

      `getAnchorNode, getNamespaceResolver, getPipelineConfiguration, getSelection, setAnchorNode, setNamespaceResolver, setPipelineConfiguration, setSelection`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AccumulatorWatch

          public AccumulatorWatch(Accumulator accumulator)

  - ### Method Detail

    - #### getContext

          public XPathContext getContext()

    - #### open

          public void open()
                    throws XPathException

      Description copied from class: `AbstractWatch`
      Open the watch. This is done at the point where it first starts watching for nodes that match the selection.
      Specified by:
        `open` in interface `Watch`
      Overrides:
        `open` in class `AbstractWatch`
      Throws:
        `XPathException`

    - #### setWatchManager

          public void setWatchManager(WatchManager watchManager)

    - #### startSelectedParentNode

          public Receiver startSelectedParentNode(FleetingNode node,
                                         int locationId)
                                           throws XPathException

      Signal that an element has been found that matches the selection that this Watch is looking for. This method is called by the WatchManager while processing the startElement event that matches the selection. For this purpose, any attributes selected by the last step in the selection are ignored
      Parameters:
        `node` - the element or document node whose start event has been matched
        `locationId` - the location associated with the element or document node (may be the location of the instruction that created it)
      Returns:
        a Receiver to be notified of all events starting with the startElement/startDocument event for the matched element, and ending with the endElement event for that element; or null if this feature is not required.
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId
        `XPathException` - May be raised if a dynamic error occurs

    - #### notifySelectedLeafNode

          public void notifySelectedLeafNode(FleetingNode node,
                                    int locationId)
                                      throws XPathException

      Signal that a node (other than an element) that matches the selection has been found.
      Specified by:
        `notifySelectedLeafNode` in interface `Watch`
      Overrides:
        `notifySelectedLeafNode` in class `AbstractWatch`
      Parameters:
        `node` - the node that was matched.
        `locationId` - the location of the node in the source document
      Throws:
        `XPathException`

    - #### endSelectedParentNode

          public void endSelectedParentNode(int locationId)
                                     throws XPathException

      Signal that the endElement event has occurred for the element whose startElement event caused the Watch to be activated.
      Parameters:
        `locationId` - the location of the element
      Throws:
        `ValidationException` - May be raised if the constraint implemented by this Watch is violated @param locationId
        `XPathException` - May be raised if a constraint implemented by this Watch is violated

    - #### close

          public void close()
                     throws XPathException

      Description copied from class: `AbstractWatch`
      The close() method is called immediately before the Watch is destroyed, that is, when the element whose declaration scopes the constraint implemented by this Watch goes out of scope. The default implementation does nothing.
      Specified by:
        `close` in interface `Watch`
      Overrides:
        `close` in class `AbstractWatch`
      Throws:
        `XPathException`

    - #### getPreDescentValue

          public Sequence getPreDescentValue()

    - #### getPostDescentValue

          public Sequence getPostDescentValue()

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.